TemplateJAMA::QR class Reference

Main Page Namespace List Compound List File List Compound Members

# JAMA::QR Class Template Reference

`#include <jama_qr.h>`

List of all members.

## Public Methods
| QR (const TNT::Array2D< Real > &A)
int | isFullRank () const
TNT::Array2D<Real> | getHouseholder (void) const
TNT::Array2D<Real> | getR () const
TNT::Array2D<Real> | getQ () const
TNT::Array1D<Real> | solve (const TNT::Array1D< Real > &b) const
TNT::Array2D<Real> | solve (const TNT::Array2D< Real > &B) const

## Detailed Description

### template<class Real> class JAMA::QR

Classical QR Decompisition: for an m-by-n matrix A with m >= n, the QR decomposition is an m-by-n orthogonal matrix Q and an n-by-n upper triangular matrix R so that A = Q*R.

The QR decompostion always exists, even if the matrix does not have full rank, so the constructor will never fail. The primary use of the QR decomposition is in the least squares solution of nonsquare systems of simultaneous linear equations. This will fail if isFullRank() returns 0 (false).

The Q and R factors can be retrived via the getQ() and getR() methods. Furthermore, a solve() method is provided to find the least squares solution of Ax=b using the QR factors.

(Adapted from JAMA, a Java Matrix Library, developed by jointly by the Mathworks and NIST; see http://math.nist.gov/javanumerics/jama).

## Constructor & Destructor Documentation

template<class Real>
JAMA::QR<Real>::QR<Real> ( | const TNT::Array2D< Real > & A )`[inline]`

  | Create a QR factorization object for A. Parameters:
  A | rectangular (m>=n) matrix.

## Member Function Documentation

template<class Real>
TNT::Array2D< Real > JAMA::QR<Real>::getHouseholder ( | void ) const`[inline]`

| Retreive the Householder vectors from QR factorization Returns: lower trapezoidal matrix whose columns define the reflections

template<class Real>
TNT::Array2D< Real > JAMA::QR<Real>::getQ ( | ) const`[inline]`

  | Generate and return the (economy-sized) orthogonal factor Parameters:
  Q | the (ecnomy-sized) orthogonal factor (Q*R=A).

template<class Real>
TNT::Array2D< Real > JAMA::QR<Real>::getR ( | ) const`[inline]`

| Return the upper triangular factor, R, of the QR factorization Returns: R

template<class Real>
int JAMA::QR<Real>::isFullRank ( | ) const`[inline]`

| Flag to denote the matrix is of full rank. Returns: 1 if matrix is full rank, 0 otherwise.

template<class Real>
TNT::Array2D< Real > JAMA::QR<Real>::solve ( | const TNT::Array2D< Real > & B ) const`[inline]`

  | Least squares solution of A*X = B Parameters:
  B | m x k Array (must conform).
Returns: X n x k Array that minimizes the two norm of Q*R*X-B. If B is non-conformant, or if QR.isFullRank() is false, the routine returns a null (0x0) array.

template<class Real>
TNT::Array1D< Real > JAMA::QR<Real>::solve ( | const TNT::Array1D< Real > & b ) const`[inline]`

  | Least squares solution of A*x = b Parameters:
  B | m-length array (vector).
Returns: x n-length array (vector) that minimizes the two norm of Q*R*X-B. If B is non-conformant, or if QR.isFullRank() is false, the routine returns a null (0-length) vector.

The documentation for this class was generated from the following file:

- jama_qr.h